package MT::Plugin::SessionTimeoutExtender;

use strict;
use base qw( MT::Plugin );
use MT;
use MT::Session;

our $VERSION = '0.01';

my $plugin = __PACKAGE__->new({
    id => 'SessionTimeoutExtender',
    name => 'SessionTimeoutExtender',
    version => $VERSION,
    description => '<MT_TRANS phrase="SessionTimeoutExtender.">',
    author_name => 'Yujiro Araki',
    author_link => 'http://www.koikikukan.com/',
    doc_link => 'http://www.koikikukan.com/archives/2012/10/03005555.php',
    l10n_class  => 'SessionTimeoutExtender::L10N',
});
MT->add_plugin( $plugin );

*MT::Session::get_unexpired_value = \&plugin_get_unexpired_value;

sub plugin_get_unexpired_value {
    my $timeout   = shift;
    my $candidate = MT::Session->load(@_);
    if ( $candidate && $candidate->start() < time - $timeout ) {
        $candidate->remove();
        $candidate = undef;
    } else {
        $candidate->start( time );
        $candidate->save;
    }
    return $candidate;
}

1;
